#ifndef OPTION_ASDL_H
#define OPTION_ASDL_H

namespace option_asdl {

#define ASDL_NAMES struct
ASDL_NAMES option_i {
  enum no_name {
  errexit = 1,
  nounset = 2,
  pipefail = 3,
  inherit_errexit = 4,
  nullglob = 5,
  verbose_errexit = 6,
  noexec = 7,
  xtrace = 8,
  verbose = 9,
  noglob = 10,
  noclobber = 11,
  posix = 12,
  vi = 13,
  emacs = 14,
  interactive = 15,
  hashall = 16,
  failglob = 17,
  extglob = 18,
  nocasematch = 19,
  eval_unsafe_arith = 20,
  _allow_command_sub = 21,
  _allow_process_sub = 22,
  dynamic_scope = 23,
  redefine_module = 24,
  _running_trap = 25,
  _running_hay = 26,
  _no_debug_trap = 27,
  strict_argv = 28,
  strict_arith = 29,
  strict_array = 30,
  strict_control_flow = 31,
  strict_errexit = 32,
  strict_nameref = 33,
  strict_word_eval = 34,
  strict_tilde = 35,
  strict_glob = 36,
  parse_at = 37,
  parse_proc = 38,
  parse_func = 39,
  parse_brace = 40,
  parse_bracket = 41,
  parse_equals = 42,
  parse_paren = 43,
  parse_ysh_string = 44,
  parse_triple_quote = 45,
  simple_word_eval = 46,
  dashglob = 47,
  command_sub_errexit = 48,
  process_sub_fail = 49,
  xtrace_rich = 50,
  xtrace_details = 51,
  sigpipe_status_ok = 52,
  redefine_proc_func = 53,
  parse_at_all = 54,
  parse_backslash = 55,
  parse_backticks = 56,
  parse_dollar = 57,
  parse_ignored = 58,
  parse_sh_arith = 59,
  parse_dparen = 60,
  parse_dbracket = 61,
  parse_bare_word = 62,
  simple_echo = 63,
  simple_eval_builtin = 64,
  simple_test_builtin = 65,
  expand_aliases = 66,
  lastpipe = 67,
  progcomp = 68,
  histappend = 69,
  hostcomplete = 70,
  cmdhist = 71,
  assoc_expand_once = 72,
  autocd = 73,
  cdable_vars = 74,
  cdspell = 75,
  checkhash = 76,
  checkjobs = 77,
  checkwinsize = 78,
  complete_fullquote = 79,
  direxpand = 80,
  dirspell = 81,
  dotglob = 82,
  execfail = 83,
  extdebug = 84,
  extquote = 85,
  force_fignore = 86,
  globasciiranges = 87,
  globstar = 88,
  gnu_errfmt = 89,
  histreedit = 90,
  histverify = 91,
  huponexit = 92,
  interactive_comments = 93,
  lithist = 94,
  localvar_inherit = 95,
  localvar_unset = 96,
  login_shell = 97,
  mailwarn = 98,
  no_empty_cmd_completion = 99,
  nocaseglob = 100,
  progcomp_alias = 101,
  promptvars = 102,
  restricted_shell = 103,
  shift_verbose = 104,
  sourcepath = 105,
  xpg_echo = 106,
  ARRAY_SIZE = 107,
  };
};

typedef int option_t;

ASDL_NAMES builtin_i {
  enum no_name {
  colon = 1,
  dot = 2,
  exec_ = 3,
  eval = 4,
  set = 5,
  shift = 6,
  times = 7,
  trap = 8,
  unset = 9,
  builtin = 10,
  readonly = 11,
  local = 12,
  declare = 13,
  typeset = 14,
  export_ = 15,
  true_ = 16,
  false_ = 17,
  try_ = 18,
  read = 19,
  echo = 20,
  printf = 21,
  mapfile = 22,
  readarray = 23,
  cd = 24,
  pushd = 25,
  popd = 26,
  dirs = 27,
  pwd = 28,
  source = 29,
  umask = 30,
  ulimit = 31,
  wait = 32,
  jobs = 33,
  fg = 34,
  bg = 35,
  shopt = 36,
  complete = 37,
  compgen = 38,
  compopt = 39,
  compadjust = 40,
  compexport = 41,
  getopts = 42,
  command = 43,
  type = 44,
  hash = 45,
  help = 46,
  history = 47,
  alias = 48,
  unalias = 49,
  bind = 50,
  append = 51,
  write = 52,
  json = 53,
  json8 = 54,
  pp = 55,
  hay = 56,
  haynode = 57,
  module = 58,
  use = 59,
  error = 60,
  fork = 61,
  forkwait = 62,
  fopen = 63,
  shvar = 64,
  ctx = 65,
  runproc = 66,
  boolstatus = 67,
  test = 68,
  bracket = 69,
  push_registers = 70,
  is_main = 71,
  cat = 72,
  ARRAY_SIZE = 73,
  };
};

typedef int builtin_t;


}  // namespace option_asdl

#endif  // OPTION_ASDL_H
